明经CAD社区

 找回密码
 注册

扫一扫,访问微社区

QQ登录

只需一步,快速开始

查看: 175|回复: 3

[讨论] 如何把line线组成的图形转换成闭合曲线并标注型心

[复制链接]
发表于 2020-6-30 07:29 | 显示全部楼层 |阅读模式
[code="lisp] (defun C:xingxin()
(setq en (car(entsel "\n选取闭合曲线:")))
;(setvar "DELOBJ" 1)
(if ( /= (get-dxf 0 en) "REGION")
(progn
(command "region" en "")
(setq en (entlast))
));if

(setq   
ENT (vlax-ename->vla-object en)
CEN (vlax-get ENT "centroid")
AREA (vlax-get ENT "AREA"))
(princ (strcat "\narea: " (rtos area 2 3)))
(princ (strcat "\ncentroid: " (vl-princ-to-string cen )))
(command "point" CEN )
(princ)
  )
  ;;get-DXF 实体dxf数据 (get-DXF code ename)
;;get-dxf code ename, Designed by 林霄云。精简自e派。进行判断的,ename必须ename。
(defun get-DXF (code ename )
(cond ((= (type ename) 'ENAME)
      (if        (= code -3)
      (cdr (assoc code (entget ename '("*"))))
      (cdr (assoc code (entget ename)))
    ))
  );COND
)[/code]这是一标注闭合曲线型心的程序,有个需要完善的地方,能否先增加一个判断,如果图形是line线组成,就把这些线改为闭合的多义线,再执行这个程序[code="lisp] (defun c:bdx( / ss i ename endata entype)
(princ "\n选择线段 <右键选择集>: ")
(setq ss (ssget '((0 . "LINE,LWPOLYLINE,ARC"))))
      (command "PEDITACCEPT" "1")
(if ss
      (command ".pedit" "m" ss "" "j" "0" "w" "0" "" "PEDITACCEPT" "0")
      (command ".pedit" "m" "p" "" "j" "0" "w" "0" "" "PEDITACCEPT" "0")
))[/code]能否把这两个程序合并为一
发表于 2020-7-1 22:20 | 显示全部楼层
本帖最后由 yshf 于 2020-7-1 22:23 编辑

(defun c:xingxin()
    (setq osmode (getvar "osmode"))
    (setvar "osmode" 0)
    (setvar "PEDITACCEPT" 1)
    (princ "\n选择线段 <右键选择集>: ")
    (if (setq ss (ssget '((0 . "LINE,LWPOLYLINE,ARC"))))
        (progn
            (command ".pedit" "m" ss "" "j" "" "")
            (setq ent0 (entlast))
            (command "region" ent0 "")
            (setq ent (entlast))
            (If (not (equal ent0 ent))
                (progn
                    (setq Obj (vlax-ename->vla-object ent)
                          CEN (vlax-get Obj "centroid")
                          AREA (vlax-get Obj "AREA")
                    )
                    (command "undo" "")
                    (princ (strcat "\narea: " (rtos area 2 3)))
                    (princ (strcat "\ncentroid: " (vl-princ-to-string cen )))
                    (command "point" CEN )
                )
           )
        )
    )
    (setvar "osmode" 0)
    (setvar "PEDITACCEPT" 0)
    (princ)
)
发表于 2020-7-2 00:07 | 显示全部楼层
谢谢! yshf 分享程序!!!!!!
 楼主| 发表于 2020-7-2 07:39 | 显示全部楼层
perfect
谢谢
您需要登录后才可以回帖 登录 | 注册

本版积分规则

小黑屋|手机版|CAD论坛|CAD教程|CAD下载|联系我们|关于明经|明经通道 ( 粤ICP备05003914号  
©2000-2020 明经通道 版权所有 本站代码,在未取得本站及作者授权的情况下,不得用于商业用途

GMT+8, 2020-7-8 09:40 , Processed in 0.175093 second(s), 29 queries , Gzip On.

Powered by Discuz! X3.3

© 2001-2013 Comsenz Inc.

快速回复 返回顶部 返回列表